#!/usr/bin/env python
# coding: utf-8




# This is easy to solve with a simple tiny wrapper:
class Callable:
    def __init__(self, anycallable):
        self.__call__ = anycallable



class EmailChecker:
	"""Ditch nonsense email addresses."""

	GENERIC_DOMAINS = "aero", "asia", "biz", "cat", "com", "coop", \
		"edu", "gov", "info", "int", "jobs", "mil", "mobi", "museum", \
		"name", "net", "org", "pro", "tel", "travel"

	def invalid(emailaddress, domains = GENERIC_DOMAINS):
		"""Checks for a syntactically invalid email address."""

		# Email address must be 7 characters in total.
		if len(emailaddress) < 7:
			return True # Address too short.

		# Split up email address into parts.
		try:
			localpart, domainname = emailaddress.rsplit('@', 1)
			host, toplevel = domainname.rsplit('.', 1)
		except ValueError:
			return True # Address does not have enough parts.

		# Check for Country code or Generic Domain.
		if len(toplevel) != 2 and toplevel not in domains:
			return True # Not a domain name.

		for i in '-_.%+.':
			localpart = localpart.replace(i, "")
		for i in '-_.':
			host = host.replace(i, "")

		if localpart.isalnum() and host.isalnum():
			return False # Email address is fine.
		else:
			return True # Email address has funny characters.
	
	invalid = Callable(invalid)

	# Start the ball rolling.
	if __name__ == "__main__":
		print invalid("C30FDE47-78C9-48A3-AB56-8A96EBDDB070@yahoo.de")

