#!/usr/bin/env python
# -*- coding: UTF-8 -*-



import os
import re
from email import EmailChecker
import subprocess
import sys
#from xml.etree import ElementTree
from tree import ElementTree

#sys.setdefaultencoding('utf-8')
print sys.getfilesystemencoding()
print sys.getdefaultencoding()
#sys.setdefaultencoding('UTF-8')


MAIN_FOLDER = '.'
MAIL_FOLDER = os.path.join(MAIN_FOLDER, 'data-pdfreaders-mails')
RES_FOLDER = os.path.join(MAIN_FOLDER, 'res')
BUGS_FOLDER = os.path.join(RES_FOLDER,'bugs')
NL_FOLDER = os.path.join(RES_FOLDER,'nl')


try:
	os.makedirs(BUGS_FOLDER)
	os.makedirs(NL_FOLDER)
except OSError:
	pass



WATCH = []



def check_watch ( lst ):
	
	for w in WATCH:
		for elt in lst:
			if (str(elt).find(w) != -1):
				return True
	return False



def get_xml (mail):
	f = open(mail, 'r')
	xml = ""
	inxml = False
	for line in f:
		if ( re.match( '<\w+', line ) ):
			inxml = True
		if (inxml):
			m = re.match( '(.*?)\=([^\"]*)$', line )
			modline = line
			if (m):
				#print '·%s·\t·%s·' % (m.group(1), m.group(2))
				modline = '%s=\"%s\"\n' % (m.group(1),m.group(2).strip('\n'))
			xml += modline.replace( '&', '&amp;' )
		if ( re.match( '\s*/>', line ) ):
			break
	f.close()
	return xml



def get_date(mail):
	
	f = open(mail, 'r')
	date = None
	for line in f:
		m = re.match('.*Date: .*, (\d\d) (\w\w\w) (2010) (\d\d:\d\d:\d\d)', line)
		if (m):
			date = (m.group(1).strip(), m.group(2), m.group(3), m.group(4))
			break
	f.close()
	return date


'''
def get_info (mail):
	
	f = open(mail)
	
	(petition, nl, begincontent) = (False, False, False)
	emailaddress, name, group, subject, date, urlcountrycode = [None]*6
	xml = ""
	content = ""
	
	inxml = False
	for line in f:
		if (begincontent):
			content += line
		if ( re.match( 'To:', line ) ):
			begincontent = True
		
		m = re.match('.*<(.*@.*\..*)>', line)
		if ( m and not EmailChecker.invalid(m.group(1)) and not re.match('.*Message-Id:', line, re.I) ):
			emailaddress = m.group(1)
		m = re.match('Subject: (.*)', line)
		if ( m ):
			subject = m.group(1)
		if ( re.match('\[X\] Petition', line) ):
			petition = True
		if ( re.match('\[X\] Newsletter', line) ):
			nl = True
		
		# example: "Date: Mon, 13 Sep 2010 11:26:46 +0000"
		m = re.match('.*Date: .*, (\d\d) (\w\w\w) (2010) (\d\d:\d\d:\d\d)', line)
		if (m):
			date = (m.group(1).strip(), m.group(2), m.group(3), m.group(4))
			#print date
		
		m = re.match('     name=\"(.*)\".*$', line)
		if ( m ):
			name = m.group(1)
		m = re.match('     group=\"(.*)\".*$', line)
		if ( m ):
			group = m.group(1)
		m = re.match('     institution-url=\"https?://[^/]*\.(.*?)/.*\"', line)
		if ( m ):
			urlcountrycode = m.group(1)
			#print urlcountrycode
		if ( re.match('<bug ', line) ):
			inxml = True
		if (inxml):
			xml += line.replace('&', '&amp;')
		if ( re.match('     />', line) ):
			inxml=False
	
	f.close()
	
	#print emailaddress
	
	## WATCH process ##
	result = (petition, nl, emailaddress, name, group, xml, content, urlcountrycode, date, subject)
	if (check_watch(result)):
		print '########## WATCH ##########\n%s\n###########################\n' % str(result)
	
	return result
'''


def get_info2 (mail):
	
	f = open(mail)
	
	(petition, nl, begincontent) = (False, False, False)
	emailaddress, subject, date = [None]*3
	content = ""
	
	inxml = False
	for line in f:
		
		# content
		if (begincontent):
			content += line
		if ( re.match( 'To:', line ) ):
			begincontent = True
		
		# enailaddress
		m = re.match('.*<(.*@.*\..*)>', line)
		if ( m and not EmailChecker.invalid(m.group(1)) and not re.match('.*Message-Id:', line, re.I) ):
			emailaddress = m.group(1)
		
		# subject
		m = re.match('Subject: (.*)', line)
		if ( m ):
			subject = m.group(1)
		
		# petition & newletter
		if ( re.match('\[X\] Petition', line) ):
			petition = True
		if ( re.match('\[X\] Newsletter', line) ):
			nl = True
		
		# date – "Date: Mon, 13 Sep 2010 11:26:46 +0000"
		m = re.match('.*Date: .*, (\d\d) (\w\w\w) (2010) (\d\d:\d\d:\d\d)', line)
		if (m):
			date = (m.group(1).strip(), m.group(2), m.group(3), m.group(4))
			#print date
	
	f.close()
	
	#print emailaddress
	
	## WATCH process ##
	result = (petition, nl, emailaddress, content, date, subject)
	if (check_watch(result)):
		print '########## WATCH ##########\n%s\n###########################\n' % str(result)
	
	return result



'''
def treat_form_mail( mail ):
	
	(petition, nl, emailaddress, name, group, xml, content, urlcountrycode, date, subject) = get_info(mail)
	
	bugslist.append( (date, xml, urlcountrycode) )
	
	if (group and group != ""):
		name =  '%s, %s' % (name,group)
	else:
		name = '%s' % name
	
	#print '%s. %s - %s %s\n%s\n' % (c, name, petition, nl, xml)
	
	coord = (name, emailaddress)
	if ( coord not in wishdict.keys()):
		wishdict[coord] = (petition, nl, content)
	else:
		wishdict[coord] = (
			wishdict[coord][0] or petition,
			wishdict[coord][1] or nl,
			wishdict[coord][2],
			wishdict[coord][3]
		)
	
	return (petition,nl)
'''


def treat_form_mail2( mail ):
	
	info = get_info2(mail)
	(petition, nl, emailaddress, content, date, subject) = info
	#print '\n\n<\n%s\n>\n\n' % content
	
	xml = get_xml(mail)
	#print xml
	bug = ElementTree.fromstring(xml)
	
	urlcountrycode = None
	m = re.match('https?://[^/]*\.(.*?)/.*', bug.attrib['institution-url'])
	if ( m ):
		urlcountrycode = m.group(1)
	
	bugslist.append( (date, xml, urlcountrycode) )
	print (date, 'xml', urlcountrycode)
	
	name = bug.attrib['name']
	if (bug.attrib['group'] != ""):
		name =  '%s, %s' % (bug.attrib['name'],bug.attrib['group'])
	
	coord = (name, emailaddress)
	if ( coord not in wishdict.keys()):
		wishdict[coord] = (petition, nl, content, None)  # we don't register country here, it's then derived from the url
	else:
		print 'conflicting wishdict entries: %s\n' % str(coord)
		wishdict[coord] = (
			wishdict[coord][0] or petition,
			wishdict[coord][1] or nl,
			wishdict[coord][2],
			None
		)
	
	print coord, wishdict[coord][0], wishdict[coord][1], '\n\n'
	
	return (petition,nl)



def treat_petition_form_mail( mail ):
	
	xml = get_xml( mail )
	sig = ElementTree.fromstring(xml)
	
	name = '%s %s' % (sig.attrib['name'], sig.attrib['surname'])
	
	if ( sig.attrib['group'] != '' ):
		name = '%s, %s' % (name,sig.attrib['group'])
	
	coord = (name, sig.attrib['email'])
	wishdict[ coord ] = ( True, sig.attrib['nl']=='[X]', None, sig.attrib['country'] )
	# we don't register 'content' here, we don't use it afterwards
	
	print coord, wishdict[coord], '\n\n'



def treat_petition_mail(mail):
	
	# petition, nl, xml have no sense in this case
	(petition, nl, emailaddress, content, date, subject) = get_info2(mail)
	
	coord = ('', emailaddress)
	# we assume the sender wants to sign the petition
	# we don't assume the sender wants to register to the nl
	# but store his or her message for possible further treatment
	wishdict[coord] = (True, False, content, "no country info")




LANGUAGECODES = {
	'United Kingdom': 'en',
	'Belgium': 'fr',
	'France': 'fr',
	'Germany': 'de',
	'Czech Republic': 'cz',
	'Poland': 'pl',
	'Serbia': 'cs',
	'Slovakia': 'sk',
	'Slovenia': 'si',
	
	'uk': 'en',
	'it': 'it',
	'ch': 'ch',
	'ca': 'en',
	'ro': 'ro',
	'fi': 'fi',
	'no': 'no',
	'ru': 'ru',
	'lu': 'lu',
	'at': 'de',
	'pt': 'pt',
	'nl': 'nl',
	'be': 'fr'
	# to be continued…
}

def getcountrycode (country, emailaddress):
	
	if (country in LANGUAGECODES):
		return LANGUAGECODES[country]
	
	m = re.match( '.*@.*\.(\w\w)', emailaddress )
	if (m and m.group(1) in LANGUAGECODES.values()):
		return m.group(1)
	if (m and m.group(1) in LANGUAGECODES.keys()):
		return LANGUAGECODES[m.group(1)]
	
	return 'xx'








mails = os.listdir(MAIL_FOLDER)
print '########## Total: %s mails to process ##########' % len(mails)

wishdict = dict()
bugslist = list()

funtreated = open( os.path.join(RES_FOLDER,'untreated.txt'), 'w')


(cf, cp, cfp, cfs, cpp, cps, cu) = [0]*7 #(0,0,0,0,0,0,0)
for mail in mails:
	
	mail = os.path.join(MAIL_FOLDER, mail)
	
	# mails concerning new bugs
	if (re.match( '.*\[PDFReaders\] New bug for', mail ) ):
		
		cf += 1
		(p,nl) = treat_form_mail2(mail)
		if (p):
			cfp += 1
		if (nl):
			cfs += 1
	
	# petition signature (form) mails
	elif ( re.match( '.*\[PDFReaders\] petition signature', mail ) ):
		
		cp += 1
		treat_petition_form_mail(mail)
	
	else:
		
		cu += 1
		(petition, nl, emailaddress, content, date, subject) = get_info2(mail)
		funtreated.write('########## %s ##########\n%s\n\n' % (mail,content))
	
	'''	
	elif (re.match ('.*p[e]ti[tz]ion', mail, re.I)):
		
		cpp += 1
		treat_petition_mail(mail)
		
	elif (re.match ('.*sign', mail, re.I)):
		
		cps += 1
		treat_petition_mail(mail)
	'''



funtreated.close()


print '########## Treated mails: ##########\n\t- %s forms;\n\t\t- %s form petition signers;\n\t\t- %s form newsletter subscribers;\n\t- %s form petition signatures;\n\t- %s contained "petition";\n\t- %s contained "sign" (but not petition);\n\t- %s were added to untreated.txt.' % (cf,cfp,cfs,cp,cpp,cps,cu)



print '########## Wishdict contains %s keys ##########' % ( len(wishdict.keys()))


fp = open( os.path.join(RES_FOLDER,'petition.txt'), 'w')
lnl = set()

cnl = 0

lp = set()
for coord in sorted(wishdict.keys()):
	
	name = coord[0]
	emailaddress = coord[1]
	petition = wishdict[coord][0]
	nl = wishdict[coord][1]
	content = wishdict[coord][2]
	country = wishdict[coord][3]
	
	# petition
	if (petition):
		if (not name or name == ""):
			name = emailaddress
		lp.add( (name,content) )
	# newsletter
	if (nl):
		cnl += 1
		lnl.add( (emailaddress, country ) )

print '########## Total: %s newsletter subscribers ##########' % cnl


#petitions
print '########## Total: %s petitions signers ##########' % len(lp)

fp.write('<ul>\n')
for nc in sorted(lp):
	name = nc[0]
	content = nc[1]
	if (name):
		fp.write( '<li>%s</li>\n' % name )
		if (not EmailChecker.invalid(name)):
			# if name is an email address, i.e. I wasn't able to find the name, put content to help manual work
			fp.write( '%s\n\n' % content )
	
fp.write('</ul>\n\n')


fp.close()



# bug files
print '########## Total: %s bugs reported ##########' % len(bugslist)

openbugfiles = dict()
for bug in sorted(bugslist):
	xml = bug[1]
	countrycode = bug[2]
	f = None
	if (countrycode in openbugfiles.keys()):
		f = openbugfiles[countrycode]
	else:
		f = open( os.path.join(BUGS_FOLDER,'bugs.%s.xml' % countrycode), 'w')
		openbugfiles[countrycode] = f
	f.write( '%s\n' % xml )


for f in openbugfiles.values():
	f.close()


# newsletters (same process: separating per country, when possible)
opennlfiles = dict()
for nl in sorted(lnl):
	emailaddress = nl[0]
	countrycode = getcountrycode(nl[1], emailaddress)
	f = None
	if (countrycode in opennlfiles.keys()):
		f = opennlfiles[countrycode]
	else:
		f = open( os.path.join(NL_FOLDER,'nl.%s.xml' % countrycode), 'w')
		opennlfiles[countrycode] = f
	f.write( '%s\n' % emailaddress )


for f in opennlfiles.values():
	f.close()




print '########## Sumcheck: ##########\n\t  %s bugs forms\n\t+ %s form petition signatures\n\t+ %s individual mails\n\t+ %s untreated\n\t= %s / %s mails' % ( len(bugslist), cp, cpp+cps, cu, len(bugslist)+cp+cpp+cps+cu, len(mails) )










